Index: libs/libmythtv/jobqueue.cpp
===================================================================
--- libs/libmythtv/jobqueue.cpp	(revision 9619)
+++ libs/libmythtv/jobqueue.cpp	(working copy)
@@ -1274,7 +1274,7 @@
     return false;
 }
 
-int JobQueue::GetJobCmd(int jobID)
+enum JobCmds JobQueue::GetJobCmd(int jobID)
 {
     MSqlQuery query(MSqlQuery::InitCon());
 
@@ -1284,18 +1284,17 @@
 
     query.exec();
 
-    if (!query.isActive())
+    if (query.isActive())
     {
-        MythContext::DBError("Error in JobQueue::GetJobCmd()", query);
-        return false;
+        if ((query.size() > 0) && query.next())
+            return (enum JobCmds)query.value(0).toInt();
     }
     else
     {
-        if ((query.size() > 0) && query.next())
-            return query.value(0).toInt();
+        MythContext::DBError("Error in JobQueue::GetJobCmd()", query);
     }
 
-    return JOB_UNKNOWN;
+    return JOB_RUN;
 }
 
 QString JobQueue::GetJobArgs(int jobID)
@@ -1308,21 +1307,20 @@
 
     query.exec();
 
-    if (!query.isActive())
+    if (query.isActive())
     {
-        MythContext::DBError("Error in JobQueue::GetJobArgs()", query);
-        return false;
+        if ((query.numRowsAffected() > 0) && query.next())
+            return query.value(0).toString();
     }
     else
     {
-        if ((query.numRowsAffected() > 0) && query.next())
-            return query.value(0).toString();
+        MythContext::DBError("Error in JobQueue::GetJobArgs()", query);
     }
 
     return QString("");
 }
 
-int JobQueue::GetJobFlags(int jobID)
+enum JobFlags JobQueue::GetJobFlags(int jobID)
 {
     MSqlQuery query(MSqlQuery::InitCon());
 
@@ -1332,21 +1330,20 @@
 
     query.exec();
 
-    if (!query.isActive())
+    if (query.isActive())
     {
-        MythContext::DBError("Error in JobQueue::GetJobFlags()", query);
-        return false;
+        if ((query.size() > 0) && query.next())
+            return (enum JobFlags)query.value(0).toInt();
     }
     else
     {
-        if ((query.size() > 0) && query.next())
-            return query.value(0).toInt();
+        MythContext::DBError("Error in JobQueue::GetJobFlags()", query);
     }
 
-    return JOB_UNKNOWN;
+    return JOB_NO_FLAGS;
 }
 
-int JobQueue::GetJobStatus(int jobID)
+enum JobStatus JobQueue::GetJobStatus(int jobID)
 {
     MSqlQuery query(MSqlQuery::InitCon());
 
@@ -1356,21 +1353,20 @@
 
     query.exec();
 
-    if (!query.isActive())
+    if (query.isActive())
     {
-        MythContext::DBError("Error in JobQueue::GetJobStatus()", query);
-        return false;
+        if ((query.size() > 0) && query.next())
+            return (enum JobStatus)query.value(0).toInt();
     }
     else
     {
-        if ((query.size() > 0) && query.next())
-            return query.value(0).toInt();
+        MythContext::DBError("Error in JobQueue::GetJobStatus()", query);
     }
-
     return JOB_UNKNOWN;
 }
 
-int JobQueue::GetJobStatus(int jobType, QString chanid, QDateTime startts)
+enum JobStatus JobQueue::GetJobStatus(int jobType, QString chanid,
+    QDateTime startts)
 {
     MSqlQuery query(MSqlQuery::InitCon());
     
@@ -1383,16 +1379,14 @@
 
     query.exec();
 
-    if (!query.isActive())
+    if (query.isActive())
     {
-        MythContext::DBError("Error in JobQueue::GetJobStatus()", query);
-        return false;
+        if (query.size() > 0 && query.next())
+            return (enum JobStatus)query.value(0).toInt();
     }
-    if (query.size() > 0 && query.next())
+    else
     {
-        int tmpStatus;
-        tmpStatus = query.value(0).toInt();
-        return tmpStatus;
+        MythContext::DBError("Error in JobQueue::GetJobStatus()", query);
     }
     return JOB_UNKNOWN;
 }
@@ -1839,8 +1833,11 @@
         {
             msg = QString("Transcode %1")
                           .arg(StatusText(GetJobStatus(jobID)));
-            gContext->LogEntry("transcode", LP_NOTICE, msg, details);
 
+            details = QString("%1%2: (%3)")
+                              .arg(program_info->title).arg(subtitle)
+                              .arg(transcoderName);
+
             if (status == JOB_FINISHED)
             {
                 retry = false;
@@ -1851,40 +1848,38 @@
                 filename = program_info->GetRecordFilename(fileprefix);
 
                 if (stat(filename.ascii(), &st) == 0)
+                {
                     filesize = st.st_size;
 
-                if (filesize != origfilesize)
-                {
                     QString comment = QString("%1: %2 => %3")
                                             .arg(transcoderName)
                                             .arg(PrettyPrint(origfilesize))
                                             .arg(PrettyPrint(filesize));
                     ChangeJobStatus(jobID, JOB_FINISHED, comment);
 
-                    details = QString("%1%2")
-                                      .arg(program_info->title).arg(subtitle);
-
                     if (filesize > 0)
-                    {
                         program_info->SetFilesize(filesize);
 
-                        details += QString(": %1 (%2)")
-                                          .arg(PrettyPrint(filesize))
-                                          .arg(transcoderName);
-                    }
-
-                    VERBOSE(VB_GENERAL, LOC +
-                            QString("%1 for %2%3: %4 => %5 (%6)")
-                            .arg(msg).arg(program_info->title).arg(subtitle)
-                            .arg(PrettyPrint(origfilesize))
-                            .arg(PrettyPrint(filesize)).arg(transcoderName));
+                    details = QString("%1%2: %3 (%4)")
+                                      .arg(program_info->title)
+                                      .arg(subtitle)
+                                      .arg(PrettyPrint(filesize))
+                                      .arg(transcoderName);
                 }
 
+                VERBOSE(VB_GENERAL, LOC +
+                        QString("%1 for %2%3: %4 => %5 (%6)")
+                        .arg(msg).arg(program_info->title).arg(subtitle)
+                        .arg(PrettyPrint(origfilesize))
+                        .arg(PrettyPrint(filesize)).arg(transcoderName));
+
                 MythEvent me("RECORDING_LIST_CHANGE");
                 gContext->dispatch(me);
 
                 program_info->SetTranscoded(TRANSCODING_COMPLETE);
             }
+
+            gContext->LogEntry("transcode", LP_NOTICE, msg, details);
         }
     }
 
Index: libs/libmythtv/jobqueue.h
===================================================================
--- libs/libmythtv/jobqueue.h	(revision 9619)
+++ libs/libmythtv/jobqueue.h	(working copy)
@@ -140,10 +140,11 @@
     static bool StopJob(int jobID);
     static bool DeleteJob(int jobID);
 
-    static int GetJobCmd(int jobID);
-    static int GetJobFlags(int jobID);
-    static int GetJobStatus(int jobID);
-    static int GetJobStatus(int jobType, QString chanid, QDateTime starttime);
+    static enum JobCmds GetJobCmd(int jobID);
+    static enum JobFlags GetJobFlags(int jobID);
+    static enum JobStatus GetJobStatus(int jobID);
+    static enum JobStatus GetJobStatus(int jobType, QString chanid,
+                        QDateTime starttime);
     static QString GetJobArgs(int jobID);
     static int UserJobTypeToIndex(int JobType);
 